/*
 *
 * Copyright (C) 2003 Sadysta ( http://sadysta.ath.cx )
 * Copyright (C) 2007 Tomasz Ostrowski ( http://ostry.w.szu.pl ) - modified from 1.8.9 source
 *
 * This file is part of Free GG.
 *
 * Free GG is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Free GG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Free GG; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Settings.h"
#include "Main.h"
#include "Activity.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSettingsForm *SettingsForm;
AnsiString settings_filename;
extern AnsiString GGDir;
//---------------------------------------------------------------------------
__fastcall TSettingsForm::TSettingsForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TSettingsForm::WriteSettings()
{
        TStringList *S;
        S = new TStringList();
        for (int i = 0; i < ListView1 -> Items -> Count; i++)
                S -> Add (ListView1 -> Items -> Item[i] -> SubItems -> Strings[0]);
        S -> SaveToFile (settings_filename);
        delete S;
}
//---------------------------------------------------------------------------
void __fastcall TSettingsForm::FormCreate(TObject *Sender)
{
		settings_filename = GGDir + "\\config.dat";

        TStringList *S;
        S = new TStringList();
        if (FileExists (settings_filename)) S -> LoadFromFile (settings_filename); else MessageBox (MainForm -> Handle, "Nie istnieje plik ustawie dla zalogowanego obecnie uytkownika.\nZa chwil zostanie utworzony plik domyslny.\n\nPlik domyslny nie zawiera ustawie umoliwiajcych prac z Free GG !!!\nKoniecznie otworz Opcje -> Ustawienia i wpisz poprawne dane !!!", "Uwaga !!!", MB_OK | MB_ICONEXCLAMATION);
        for (int i = 0; i < 26; i++)
        {
                TListItem *I = ListView1 -> Items -> Add();
                if (i < S -> Count) I -> SubItems -> Add (S -> Strings[i]); else
                                    I -> SubItems -> Add ("0");
        }
        ListView1 -> Items -> Item[0] -> Caption = "Gadu-Gadu UIN";
        ListView1 -> Items -> Item[1] -> Caption = "Haslo";
        ListView1 -> Items -> Item[2] -> Caption = "Domyslny status";
        ListView1 -> Items -> Item[3] -> Caption = "Moja ksywa";
        ListView1 -> Items -> Item[4] -> Caption = "Dwik wiadomosci";
        ListView1 -> Items -> Item[5] -> Caption = "Pozycja X";
        ListView1 -> Items -> Item[6] -> Caption = "Pozycja Y";
        ListView1 -> Items -> Item[7] -> Caption = "Szerokosc";
        ListView1 -> Items -> Item[8] -> Caption = "Wysokosc";
        ListView1 -> Items -> Item[9] -> Caption = "Opis statusu";
        ListView1 -> Items -> Item[10] -> Caption = "Przezroczysto";
        ListView1 -> Items -> Item[11] -> Caption = "Tylko dla znajomych";
        ListView1 -> Items -> Item[12] -> Caption = "Uruchom zminimalizowany";
        ListView1 -> Items -> Item[13] -> Caption = "Pokaz komunikat systemowy";
        ListView1 -> Items -> Item[14] -> Caption = "Ostatni komunikat systemowy";
        ListView1 -> Items -> Item[15] -> Caption = "Logowanie aktywnosci";
        ListView1 -> Items -> Item[16] -> Caption = "Uzyj powiadomien";
        ListView1 -> Items -> Item[17] -> Caption = "Oznaczenie wiadomosci kodowanej";
        ListView1 -> Items -> Item[18] -> Caption = "Oznaczenie wiadomosci niekodowanej";
        ListView1 -> Items -> Item[19] -> Caption = "Wznawiaj zerwane polaczenia";
        ListView1 -> Items -> Item[20] -> Caption = "Login na bramke Era Podstawowa";
        ListView1 -> Items -> Item[21] -> Caption = "Haslo na bramke Era Podstawowa";
        ListView1 -> Items -> Item[22] -> Caption = "Login na bramke Era Omnix";
        ListView1 -> Items -> Item[23] -> Caption = "Haslo na bramke Era Omnix";
        ListView1 -> Items -> Item[24] -> Caption = "Logowanie SMS";
        ListView1 -> Items -> Item[25] -> Caption = "Logowanie w oknie glownym";
        delete S;

        Edit1 -> Text = ListView1 -> Items -> Item[0] -> SubItems -> Strings[0];
        Edit2 -> Text = ListView1 -> Items -> Item[1] -> SubItems -> Strings[0];
        Edit3 -> Text = ListView1 -> Items -> Item[3] -> SubItems -> Strings[0];
        switch (StrToInt (ListView1 -> Items -> Item[2] -> SubItems -> Strings[0]))
        {
                case 2:
                        ComboBox1 -> ItemIndex = 0;
                break;

                case 3:
                        ComboBox1 -> ItemIndex = 1;
                break;

                case 20:
                        ComboBox1 -> ItemIndex = 2;
                break;
        }
        Edit5 -> Text = ListView1 -> Items -> Item[9] -> SubItems -> Strings[0];
        CheckBox1 -> Checked = StrToInt (ListView1 -> Items -> Item[11] -> SubItems -> Strings[0]);
        Edit4 -> Text = ListView1 -> Items -> Item[4] -> SubItems -> Strings[0];
        TrackBar1 -> Position = StrToInt (ListView1 -> Items -> Item[10] -> SubItems -> Strings[0]);
        CheckBox2 -> Checked = StrToInt (ListView1 -> Items -> Item[12] -> SubItems -> Strings[0]);
        CheckBox3 -> Checked = StrToInt (ListView1 -> Items -> Item[13] -> SubItems -> Strings[0]);
        ActivityForm -> CheckBox1 -> Checked = StrToInt (ListView1 -> Items -> Item[15] -> SubItems -> Strings[0]);
        ActivityForm -> CheckBox2 -> Checked = StrToInt (ListView1 -> Items -> Item[16] -> SubItems -> Strings[0]);
        ActivityForm -> CheckBox2 -> Enabled = ActivityForm -> CheckBox1 -> Checked;
        CheckBox4 -> Checked = StrToInt (ListView1 -> Items -> Item[19] -> SubItems -> Strings[0]);
        CheckBox5 -> Checked = StrToInt (ListView1 -> Items -> Item[25] -> SubItems -> Strings[0]);
}
//---------------------------------------------------------------------------
void __fastcall TSettingsForm::ListView1InfoTip(TObject *Sender,
      TListItem *Item, AnsiString &InfoTip)
{
        switch (Item -> Index)
        {
                case 4:
                  InfoTip = "0 - dwik wylaczony\n1 - dwik wlczony";
                break;

                case 2:
                  InfoTip = "2 - dostpny\n3 - zajty\n20 - niewidoczny";
                break;

                default:
                  InfoTip = "";
                break;
        }
}
//---------------------------------------------------------------------------

void __fastcall TSettingsForm::ListView1Click(TObject *Sender)
{
        if (ListView1 -> Selected)
        {
                AnsiString S = ListView1 -> Selected -> SubItems -> Strings[0];
                if (InputQuery("Retrieve article header", "Which article header to retrieve", S))
                    ListView1 -> Selected -> SubItems -> Strings[0] = S;
        }
}
//---------------------------------------------------------------------------

void __fastcall TSettingsForm::ListView1CustomDrawSubItem(
      TCustomListView *Sender, TListItem *Item, int SubItem,
      TCustomDrawState State, bool &DefaultDraw)
{
        if (Item -> Index == 1) DefaultDraw = false;
}
//---------------------------------------------------------------------------

void __fastcall TSettingsForm::Button1Click(TObject *Sender)
{
        ListView1 -> Items -> Item[0] -> SubItems -> Strings[0] = Edit1 -> Text;
        ListView1 -> Items -> Item[1] -> SubItems -> Strings[0] = Edit2 -> Text;
        ListView1 -> Items -> Item[3] -> SubItems -> Strings[0] = Edit3 -> Text;
        switch (ComboBox1 -> ItemIndex)
        {
                case 0:
                        ListView1 -> Items -> Item[2] -> SubItems -> Strings[0] = "2";
                break;

                case 1:
                        ListView1 -> Items -> Item[2] -> SubItems -> Strings[0] = "3";
                break;

                case 2:
                        ListView1 -> Items -> Item[2] -> SubItems -> Strings[0] = "20";
                break;
        }
        ListView1 -> Items -> Item[9] -> SubItems -> Strings[0] = Edit5 -> Text;
        ListView1 -> Items -> Item[11] -> SubItems -> Strings[0] = IntToStr (CheckBox1 -> Checked);
        ListView1 -> Items -> Item[4] -> SubItems -> Strings[0] = Edit4 -> Text;
        ListView1 -> Items -> Item[10] -> SubItems -> Strings[0] = IntToStr (TrackBar1 -> Position);
        ListView1 -> Items -> Item[12] -> SubItems -> Strings[0] = IntToStr (CheckBox2 -> Checked);
        ListView1 -> Items -> Item[13] -> SubItems -> Strings[0] = IntToStr (CheckBox3 -> Checked);
        ListView1 -> Items -> Item[19] -> SubItems -> Strings[0] = IntToStr (CheckBox4 -> Checked);
        ListView1 -> Items -> Item[25] -> SubItems -> Strings[0] = IntToStr (CheckBox5 -> Checked);
		MainForm->SetTransparentWindow(StrToInt(ListView1 -> Items -> Item[10] -> SubItems -> Strings[0]));
}
//---------------------------------------------------------------------------


void __fastcall TSettingsForm::SpeedButton1Click(TObject *Sender)
{
        TOpenDialog* D = new TOpenDialog (NULL);
        D -> Filter = "Wave-form files (*.wav)|*.wav";
        D -> DefaultExt = "wav";
		if (D -> Execute()) Edit4 -> Text = D -> FileName;
		delete D;
}
//---------------------------------------------------------------------------

